#ifndef PIPEWIRESENSOR_H
#define PIPEWIRESENSOR_H

#include <QObject>
#include <string>
#include <pipewire/core.h>
#include <pipewire/pipewire.h>
#include <QTimer>

#include "sensor.h"
#include "../pipewire.h"

class PipeWireSensorSource : public QObject
{
	Q_OBJECT

	PipeWireHandler* handler_;
	std::string nodeName_;
	struct pw_node* sinkNode = nullptr;
	struct spa_hook sinkListener;
	pw_node_state prevState = PW_NODE_STATE_SUSPENDED;
	QTimer timer;
	uint8_t id_;
	bool state = false;

private slots:
	void offTimeout();

public:
	explicit PipeWireSensorSource(PipeWireHandler* handler, const std::string& nodeName, uint8_t id, QObject *parent = nullptr);
	static void nodeEventHandler(void* data, const struct pw_node_info *info);

signals:
	void stateChanged(Sensor sensor);

private slots:
	void nodeAdded(PipeWireHandler::PwNode node);
};

#endif // PIPEWIRESENSOR_H
